//
//  NanMapFlutterFactory.m
//  Runner
//
//  Created by 周泽南 on 2021/8/12.
//

#import "NanMapFlutterFactory.h"
#import "NanMapView.h"

@implementation NanMapFlutterFactory{
    NSObject<FlutterPluginRegistrar>*_registrar;
}

-(instancetype)initWithRegistrar:(NSObject<FlutterPluginRegistrar> *)registrar{
    if (self = [super init]) {
        _registrar = registrar;
    }
    return self;
}

-(NSObject<FlutterMessageCodec> *)createArgsCodec{
    return [FlutterStandardMessageCodec sharedInstance];
}

- (nonnull NSObject<FlutterPlatformView> *)createWithFrame:(CGRect)frame viewIdentifier:(int64_t)viewId arguments:(id _Nullable)args {
    NanMapView *mapView = [[NanMapView alloc]initWithFrame:frame viewIdentifier:viewId arguments:args registrar:_registrar];
    return mapView;
}

@end
